import React, { useState } from 'react'
import { Menu, Layout } from 'antd';
import {
    DesktopOutlined,
    DollarCircleOutlined,
    PieChartOutlined,
    TeamOutlined,
    UserOutlined,
} from '@ant-design/icons';
import { getRoute } from '../../../utils/Api';
import {useNavigate,useLocation } from 'react-router-dom'

const { Sider } = Layout;

function getItem(label, path, icon, children) {
    return {
        label,
        key:path,
        icon,
        children,
    };
}

const items = [
    getItem('今日随机', '/show/generate', <DollarCircleOutlined />),
    getItem('历史数据', '/show/sync', <PieChartOutlined />),
    getItem('数据曲线图', '/show/probability', <DesktopOutlined />),
    // getItem('用户', 'sub1', <UserOutlined />, [
    //     getItem('Tom', '3'),
    //     getItem('Bill', '4'),
    //     getItem('Alex', '5'),
    // ]),
    // getItem('团队', 'sub2', <TeamOutlined />, [
    //     getItem('Team 1', '6'), 
    //     getItem('Team 2', '8')
    // ]),
];
const items1=getRoute()

function bulidRoute(routeList){
    if(routeList){
        for (let route of routeList){
            getItem(route.label, route.path, route.icon, bulidRoute(route.childMenuRouteList))
        }
    }
}

const TSlide = (props) => {
    const [collapsed, setCollapsed] = useState(false);
    const [current, setCurrent] = useState('1');
	const navigate = useNavigate()
    let location = useLocation();
    const onClick = (e) => {
        setCurrent(e.key);
        navigate(e.key)
    };

items1.then(function(data){
    // bulidRoute(data.data)
    console.log('dunctiondata',data)
    console.log('dunctiondataitems',items)
})
    return (
        <Sider collapsible collapsed={collapsed} onCollapse={(value) => setCollapsed(value)}>
            <div className="logo"></div>
            <Menu theme="dark" defaultSelectedKeys={[location.pathname]} mode="inline" onClick={onClick} items={items} >
            </Menu>
        </Sider>
    );
};
export default TSlide