import {combineReducers, configureStore} from '@reduxjs/toolkit'
import historyReducer from './historyRecord_reducer'
import redirectReducer from './redirectUrl_reducer'
import dirMessageReducer from './dirMessage_reducer'
import clickFileReducer from './clickFile_reducer'
import pushHotkeysReducer from "./pushHotkeys_reducer";
import tableBarItemReducer from "./tableBarItem_reducer";
import {electronStorage} from "../utils/LocalStorage";
import { persistStore, persistReducer } from 'redux-persist'
// 持久化配置

const historyRecordPersistConfig = {
    key: 'historyRecord',
    storage: electronStorage()
}
const redirectUrlPersistConfig = {
    key: 'redirectUrl',
    storage: electronStorage()
}
const dirMessagePersistConfig = {
    key: 'dirMessage',
    storage: electronStorage()
}
const pushHotkeysPersistConfig = {
    key: 'pushHotkeys',
    storage: electronStorage()
}
const clickFileMessagePersistConfig = {
    key: 'clickFileMessage',
    storage: electronStorage()
}
const tableBarItemPersistConfig = {
    key: 'tableBarItem',
    storage: electronStorage()
}


const historyRecordPersistedReducer = persistReducer(historyRecordPersistConfig, historyReducer)
const redirectUrlPersistedReducer = persistReducer(redirectUrlPersistConfig, redirectReducer)
const dirMessagePersistedReducer = persistReducer(dirMessagePersistConfig, dirMessageReducer)
const pushHotkeysPersistedReducer = persistReducer(pushHotkeysPersistConfig, pushHotkeysReducer)
const clickFileMessagePersistedReducer = persistReducer(clickFileMessagePersistConfig, clickFileReducer)
const tableBarItemPersistedReducer = persistReducer(tableBarItemPersistConfig, tableBarItemReducer)

export const store = configureStore({
    reducer: {
        historyRecord:historyRecordPersistedReducer,
        redirectUrl:redirectUrlPersistedReducer,
        dirMessage:dirMessagePersistedReducer,
        pushHotkeys:pushHotkeysPersistedReducer,
        clickFileMessage:clickFileMessagePersistedReducer,
        tableBarItem:tableBarItemPersistedReducer
    }
})
export const  persistor = persistStore(store);
